variables:
    FF_USE_FASTZIP: "true" # enable fastzip - a faster zip implementation that also supports level configuration.
    ARTIFACT_COMPRESSION_LEVEL: default
    CACHE_COMPRESSION_LEVEL: default
    TRANSFER_METER_FREQUENCY: 5s # will display transfer progress every 5 seconds for artifacts and remote caches.
    MAVEN_OPTS: "-Djava.awt.headless=true -Dmaven.repo.local=${CI_PROJECT_DIR}/.m2/repository/"
    MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version"
    SONAR_USER_HOME: ${CI_PROJECT_DIR}/.sonar  # Defines the location of the analysis task cache
    GIT_DEPTH: 0  # Tells git to fetch all the branches of the project, required by the analysis task

cache:
  key: ${CI_COMMIT_REF_SLUG} # To have jobs in each branch use the same cache
  #key: $CI_JOB_NAME-$CI_COMMIT_REF_SLUG # Per-job and per-branch caching
  paths:
    - ${CI_PROJECT_DIR}/.m2/repository/

#image: alpine
#image: maven:3.6-jdk-11-alpine
#image: maven:3.6-jdk-11

stages:
#  - Flyway
  - build
  #- test
  #- sonarqube
  #- test-build
  - dockerimage-ext-job

#stage-flyway:
#  stage: Flyway
#  image: maven:3.6.3-jdk-11
#  script:
#    - mvn flyway:info flyway:migrate flyway:info


stage-build:
  image: maven:3.6-jdk-8
  stage: build
  cache:
    paths:
      - ${CI_PROJECT_DIR}/.m2/repository/
  script:
    - mvn clean package -DskipTests=true
    - printenv
    - |
      if [[ "$CI_COMMIT_TAG" == "" ]]; then
        echo "ARTIFACTS_DOWNLOAD_REF=$CI_COMMIT_BRANCH" > variables.env
      else
        echo "ARTIFACTS_DOWNLOAD_REF=$CI_COMMIT_TAG" > variables.env
      fi
    - echo CI_COMMIT_BRANCH $CI_COMMIT_BRANCH
    - echo ARTIFACTS_DOWNLOAD_REF ${ARTIFACTS_DOWNLOAD_REF}
    - echo CI_COMMIT_SHORT_SHA_CHILD CI_COMMIT_SHORT_SHA $CI_COMMIT_SHORT_SHA
    - echo current CI_COMMIT_TAG $CI_COMMIT_TAG
    - echo current tag ${tag}
  artifacts:
    paths:
      - ./deploy/conf/*
      - ./Dockerfile
      - target/*.war
    reports:
      dotenv: variables.env
  only:
    - main
    - master
    - develop
    - tags

.stage-test:
  stage: test
  cache:
    paths:
      - ${CI_PROJECT_DIR}/.m2/repository/
  image: maven:3.6-jdk-8
  script:
    - mvn test -Dskip.asciidoc=true
  artifacts:
     paths:
       - target/
       - src/
     reports:
      junit:
       - target/surefire-reports/TEST-*.xml
  only:
    - main
    - master
    - develop
    - tags

.sonarqube-check:
  stage: sonarqube
  image:
    name: sonarsource/sonar-scanner-cli:4.6
    entrypoint: [""]
  cache:
    key: ${CI_JOB_NAME}
    paths:
      - ${CI_PROJECT_DIR}/.sonar/cache
  script:
    - sonar-scanner -Dsonar.qualitygate.wait=true
  allow_failure: true
  dependencies:
    - stage-test
  only:
    - main
    - master
    - develop
    - tags

staging-external:
  stage: dockerimage-ext-job
  trigger: openkonsequenz/qa/portal-build-job
  variables:
    ARTIFACTS_DOWNLOAD_REF: $ARTIFACTS_DOWNLOAD_REF
    CI_COMMIT_TAG_CHILD: $CI_COMMIT_TAG
    CI_COMMIT_SHORT_SHA_CHILD: $CI_COMMIT_SHORT_SHA
  needs:
    - stage-build
  only:
    - main
    - master
    - develop
    - tags
